/*
   Copyright 2006 Michael Jung

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

package org.apache.batik.util;

import java.awt.image.*;
import java.awt.*;
import javax.imageio.*;
import javax.imageio.stream.*;

public class SVGReaderSpi extends javax.imageio.spi.ImageReaderSpi {
    static final Class[] it = { ImageInputStream.class };
    public boolean canDecodeInput(Object source) {
        if (source instanceof FileImageInputStream) {
            FileImageInputStream fii = (FileImageInputStream) source;
            try {
                for (int i = 0; i < 10; i++) {
                    String str = fii.readLine();
                    if (str.matches(".*-//W3C//DTD *SVG.*") ||
                        str.matches(".*<svg")) {
                        fii.reset();
                        return true;
                    }
                }
            }
            catch(Exception e) {
                return false;
            }
        }
        return false;
    }
    public ImageReader createReaderInstance(Object extension) {
        return new SVGReader(this);
    }
    public String getDescription(java.util.Locale loc) {
        return "Reads SVG images";
    }
    public Class[] getInputTypes() { return it; }
}
